var _UniqIndex = 1; 
jQuery.fn.extend({
    uniqIndex: function(){
    var i = this.attr("uniqIndex");
    if (i) 
        return i;
    else {
        this.attr("uniqIndex", _UniqIndex);
        return _UniqIndex++;
    }
    },
    switchNode:function(b){
        this.clone(true).insertAfter(b);
        this.replaceWith(b);   
    }
}); 

var g_GameNameList = ["game-3","game-5","game-2","game-1","game-0"];//"game-6",
var g_GameNameMap = {
      "game-1":{
          "n":"24点",
          "url":"style/images/sp_03.jpg",
          "tips":"答案",
          "desc":"思维++ 计算+ 想象+",
          "game_desc":"通过+ - x ÷ 运算<br/>得出24吧",
          "level":[15,15,15,15],
          "game_time":180
          },
      "game-2":{
          "n":"翻牌记忆",
          "url":"style/images/sp_06.jpg",
          "tips":"",//全部翻开
          "desc":"记忆++ 反应+ 思维+",
          "game_desc":"点击扑克牌<br/>找出相同的牌",
          "level":[12,12,12,12],
          "game_time":60
          },
      "game-3":{
          "n":"快速计算",
          "url":"style/images/sp_10.jpg",
          "tips":"",//答案
          "desc":"计算++ 反应+ 思维+",
          "game_desc":"填上+ - x ÷ <br/>使等式成立",
          "level":[21,21,21,21],
          "game_time":60
          },
      "game-4":{
          "n":"战胜黑暗",
          "url":"style/images/sp_10.jpg",
          "tips":"答案",
          "desc":"想象++ 思维+",
          "game_desc":"拖动移动点<br/>使所有的黑点变亮",
          "level":[20,20,20,20],
          "game_time":180
          },
      "game-5":{
          "n":"逐个击破",
          "url":"style/images/sp_08.jpg",
          "tips":"",//时间静止
          "desc":"反应++",
          "game_desc":"按正确的次序<br/>依序点击数字",
          "level":[15,15,15,15],
          "game_time":60
          },
      "game-6":{
          "n":"数独",
          "url":"style/images/sp_08.jpg",
          "tips":"",//时间静止
          "desc":"反应++",
          "game_desc":"填入数字1~9<br/>使每行，每列，每9宫格，均是0~9",
          "level":[15,15,15,15],
          "game_time":60
          },
      "game-0":{
          "n":"智力题",
          "url":"style/images/game_0.jpg",
          "tips":"答案",//时间静止
          "desc":"反应++",
          "game_desc":"根据题目<br/>选择正确答案",
          "level":[15,15,15,15],
          "game_time":180
          }
  };

function getMaxLevel(game,big)
{
   if(g_GameNameMap[game])
   {
    var level_list = g_GameNameMap[game].level;  
    return level_list[big-1];
   }
   else
    return 0;  
}

function getNextLevel(game,level)
{
   if(g_GameNameMap[game])
   {
    var level_list = g_GameNameMap[game].level;  
    var level_s = level%10000;
    var level_b = parseInt(level/10000) ;
    var max = level_list[level_b-1];
    if(max)
    {
        if((max-1)==level_s)
        {
            if(level_b <level_list.length)
                return (level_b+1)*10000;
            else
                return (level_b*10000 + 9999);
        }
        else
        {
            return (level+1);
        }
    }
   }
   return -1;
}

function showGameDesc(game,divID,clock_fun)
{
//    clock_fun();
//    return ;
   var name = g_GameNameMap[game].n;
   var desc = g_GameNameMap[game].game_desc;
   var html ='<div id="game_desc" class="main-container theme-default page-pk">"><div  class="main va-outer"><div class="va-middle"><div class="txtBar tac">'
            +'<div class="txt-round c-orange"><p><span class="fa"><strong id="round_desc"></strong></span><br/>'
            +'<span class="fa" id="game_name">'+name+'</span></p></div>'
            +'<div class="txt-tips"><p >'+desc+'</p></div>'
            +'<p id="time_left_area" class="txt-time dib" style="display:none"><span id="time_left"></span></p>'
            +'</div></div></div></div>';
    $("body").append(html);
    $("#"+divID).hide();
    if(clock_fun)
    {
        $("#time_left_area").show();
        SimpleClock.run(3,1000,function(e){
            $("#time_left").html(parseInt(e/1000));   
        },
        function(e){
          $("#time_left_area").hide();
          $("#"+divID).show(); 
          clock_fun();   
        });
    }      
}

var g_user_obj = {"pid":"","sid":"","uid":0};

var click_type = "ontouchstart";
var HOST = "http://115.29.33.113/2/";

//0:mobile 1：pc 2:mobile_test 3:pc_test
var debug_flag = 0;
if(debug_flag)
{
    if(debug_flag==1 || debug_flag == 3)
    {
        click_type = "onmousedown";        
    }

    if(debug_flag==2 || debug_flag == 3)
        HOST = "http://115.29.33.113/test_2/";
}   


function getUrlParam(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
    var r = window.location.search.substr(1).match(reg);  //匹配目标参数
    if (r != null) return unescape(r[2]); return null; //返回参数值
}

function getStorageUrl(index)
{
    var s = getStorage("url_param").split(",");
    if(index=="type")
        return s[0];
    else if(index =="name")
        return s[1];
    else if(index == "level")
        return parseInt(s[2]);
    else if(index =="level_b")
        return parseInt(parseInt(s[2])/10000);
    else if(index =="level_s")
        return parseInt(s[2])%10000;
    else
        return s;
}

function setStorageUrl()
{
    var u = "";
    var n = arguments.length;
    for(var i=0;i <n;i++)
        u += (arguments[i] + ",");
    setStorage("url_param",u)
}

function json2str(o) { 
    var arr = []; 
    var fmt = function(s) { 
        if (typeof s == 'object' && s != null)
            return json2str(s); 
        return /^(string|number)$/.test(typeof s) ? "'" + s + "'" : s; 
    } 
    
    for (var i in o) 
        arr.push("'" + i + "':" + fmt(o[i])); 
    return '{' + arr.join(',') + '}'; 
} 

function clone(myObj){  
    if(typeof(myObj) != 'object' || myObj == null) return myObj;  
    var newObj = new Object();  
    for(var i in myObj){  
      newObj[i] = clone(myObj[i]); 
    }  
    return newObj;  
}


function setStorageObj(key,obj)
{
    var s = json2str(obj);
    setStorage(key,s);
}

function getStorageObj(key)
{
    var s = getStorage(key);
    eval("var obj = "+s); 
    return obj;
}


//resize the windows
function init_resize(){
  var ww=$(document).width();
  var ss=ww/10.8;
  $("body").css("font-size",ss+"px");   
}

function close_window()
{
    appcan.window.close(-1,400);
}

function refreshPage(name)
{
    uexWindow.evaluateScript(name, 0, 'refresh();');   
}

function gotoPage(page_name){
     appcan.window.open({
        name:page_name,
        dataType:0,
        data:"./"+page_name+".html",
        aniId:10,
        animDuration:400
    });
}

function myAlert(msg,title)
{
    uexWindow.cbConfirm = null;
    if(!title)
        title = "提示";
    uexWindow.confirm(title,msg,"确定");    
}

function showGameResultTips(type)
{
    var cssname = (parseInt(type)==0?"right_tips":"wrong_tips");
    if(document.getElementById('game_result_tips'))
    {
       $("#game_result_tips").attr("class",cssname);
       $("#game_result_tips").show(); 
    }
    else
    {
        var html = '<div id="game_result_tips" class="'+cssname+'"></div>';
        $("body").append(html);          
    }
    setTimeout(function(){$("#game_result_tips").hide();},500);
}

function document_width()
{
   var ww=$(document).width();
   return parseInt(ww);
}

function document_height()
{
    var ww=$(document).height();
    return parseInt(ww);
}

function getUserTitle(level)
{
    var mid = ["不错的","优秀的","出色的","聪明的","高明的","睿智的","顶尖的","天才"];
    var hou = ["小学生","初中生","高中生","大学生","硕士","博士","博士后","博士后导师"];
    return mid[level%mid.length] + hou[parseInt(level/hou.length)];
}

function getUserLevel(point){
    var l = 0;
    var n = 0;
    var t =100;
    if(point<1000)
    {
        l = parseInt(point/100);
        n = point%100;
        t = 100;
    }
    else if(point <= 165000)
    {
        l = Math.sqrt((point-1000+25)/100)- 0.5+10;
        var n_i = parseInt(l-10);
        t = (n_i +1)*200;
        n = point - ((n_i+1)*n_i/2*200 + 1000); 
    }
    else
    {
        l = 40;
        t = 100;
        n = 100;
        
    }
    return {"l":l+100,"next_total":t,"next_cur":n};
}

function getIQLevel(a,b,c,d,e)
{
    return (Math.sqrt(a) + Math.sqrt(b) + Math.sqrt(c) + Math.sqrt(d) + Math.sqrt(e))/5;
}

function GameRecord(){};
GameRecord.init = function(){
    this.list = [];
}
GameRecord.add = function(game,level,sec,failed){
   var s = game + ":"+level + ":" + (failed==1?"-":"") + sec ;
   this.list.push(s);
}
GameRecord.get = function(){
    return this.list.join("|");
}

function SimpleClock(){};
SimpleClock.run = function(time,interval_ms,onfun,cb){
    this.max_time = time;
    this.time = time*1000/interval_ms;
    this.interval_ms = interval_ms;
    this.onfun = onfun;
    this.cb = cb;
    
    this.clock = setInterval(function(){SimpleClock.onclock();},interval_ms);
}

SimpleClock.onclock = function(){
    if(this.onfun)
        this.onfun(this.time*this.interval_ms);
    
    if(this.time <=0)
    {
        clearInterval(this.clock);
        this.clock = null;
        if(this.cb)
            this.cb();
    }
    this.time--;
}



function TimeClock(){};
TimeClock.init = function(time_max_sec,interval_ms,progressId,cb,onSecFun){
    this.time = 0;
    this.clock = null;
    
    this.go_ms = 0;
    this.go_s = 0;
    
    this.time_max = time_max_sec;
    this.interval = interval_ms;
    this.progressId = progressId;
    this.callBack = cb;
    this.callSecCall = onSecFun;
}

TimeClock.start = function()
{
    if(this.clock)
    {
        clearInterval(this.clock);
    }
    this.time  = parseInt(this.time_max*1000/this.interval); 
    this.clock = setInterval(function(){TimeClock.onclock();},this.interval);   
}

TimeClock.stop = function(){
    if(this.clock)
    {
        clearInterval(this.clock);
        this.clock = null;
    }   
}

TimeClock.timeAdd = function(sec)
{
    var t = (sec*1000/this.interval);
    this.time +=t;    
}

TimeClock.getGoneSec = function(sec)
{
    return this.go_s;
}

TimeClock.onclock = function()
{
    var percent = (this.time*this.interval)/(this.time_max*10);
    if(this.progressId)
        $("#"+this.progressId).width(percent+"%");
    
    this.go_ms +=this.interval;
    if(parseInt(this.go_ms/1000) > this.go_s)
    {
        this.go_s = parseInt(this.go_ms/1000);
        if(this.callSecCall)
            this.callSecCall(this.go_s);
    }
    
    if(this.time <=0)
    {
        clearInterval(this.clock);
        this.clock = null;
        
        if(this.callBack)
            this.callBack();
    }
    this.time--;
}

TimeClock.getGrogress = function(){
    var percent = (this.time*this.interval)/(this.time_max*10);
    return percent;
}

//
//存储数据
function setStorage(key,val){
    if(window.localStorage)
        localStorage.setItem(key,val);
    else
        alert('不支持web storage.');
}

//从存储中取数据
function getStorage(key){
    if(window.localStorage)
        return localStorage.getItem(key);
    return '';
}

function getStorageInt(key,default_value)
{
    var v =  getStorage(key);
    if(v ==null)
        v = default_value;
    return parseInt(v);
}

//清除数据
function clearstorage(key){
    if(window.localStorage)
        if(key)
            localStorage.removeItem(key);
        else
            localStorage.clear();
    else
        alert('不支持web storage.');   
}

function setLoginInfo()
{
    setStorage("uid",g_user_obj.uid);
    setStorage("sid",g_user_obj.sid);
}

function getLoginInfo()
{
    g_user_obj.uid = getStorageInt("uid");
    g_user_obj.sid = getStorage("sid");
}

// 1 - 52;
function Number2PokerCss(num)
{
    var v = num % 13;
    if(v==0)
        v = 13;
    var poker = new Array('-b','-r','-f','-m');     
    v = v + poker[parseInt((num-1)/13)];
    return v;   
}

function getCurrentSec()
{
    var d = new Date();
    return parseInt(d.getTime()/1000);
}

//不重复的随机遍历数组下标
function MyRand(){
    this._num = 0;
    this._idx = -1;
    this._array = [];
    
    this.init = function(start,step,max){
        this._array = [];
        this._num =0;
        if(step<0)
            step =-step;
        for(var i=start; i<=max; i+=step)
        {
            this._array[this._num] = start+this._num*step;
            this._num++;
        }

        this._idx = this._num -1;       
    };
    this.initArray = function(array){
        this._array = array;
        this._num = array.length;
        this._idx = this._num -1;
    };
    this.get = function(){
        if(this._idx <0)
            this._idx = this._num -1;
            
        var index = parseInt(Math.random()*this._idx);
        var value = this._array[index];
        this._array[index]=this._array[this._idx];
        this._array[this._idx] = value;
        this._idx --;
        return value;           
    };
    this.seqGet = function(num)
    {
        var a = [];
        if(this._num >= num)
        {
            var t = this._num - num + 1;
            var start = parseInt(Math.random()*100000)%t;
            for(var j=0;j<num;j++)
            {
                a[j]=this._array[j+start];
            }
        }
        return a;
    } 
};

function sortArray(array,order)
{
    var tmp = 0;
    var len = array.length;
    for(var i=0;i<len;i++)
    {
        for(var j=i+1;j<len;j++)
        {
            if(array[i]>array[j])
            {
                tmp = array[i];
                array[i] = array[j];
                array[j] = tmp;
                
            }
        }        
    }

    if(order ==1)
    {
        for(var i=0; i<len/2;i++)
        {
            tmp = array[i];
            array[i] = array[len-i-1];
            array[len-i-1] =tmp;
        }
    }       
    return array;
}
